#ifndef _FBAB_H
#define _FBAB_H

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

typedef struct {
    FILE * file; // Fichier lu ou écrit
    unsigned char tampon; // Tampon de 8 bits, à remplir avant écriture
    signed char position; // Position dans le tampon
} FBAB;

FBAB * fbab_open(char * filename, char * flags);
void fbab_close(FBAB * f);
void fbab_flush(FBAB * f);

inline int fbab_writebit(unsigned char bit, FBAB * f);
int fbab_write8(unsigned char data, FBAB * f);
int fbab_writediff(unsigned short data, FBAB * f);

inline int fbab_readbit(unsigned char * bit, FBAB * f);
int fbab_read8(unsigned char * data, FBAB * f);
int fbab_readdiff(unsigned short * data, FBAB * f);

#endif /* _FBAB_H */
